package jsonrpc

// GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.

import (
	"context"
	"encoding/json"

	"gitlab.com/accumulatenetwork/core/wallet/cmd/accumulate/walletd/api"
)

type Client struct {
	Transport Transport
	Server    string
}

func (c *Client) Decode(ctx context.Context, req *api.DecodeRequest) (*api.DecodeResponse, error) {
	return callClient[*api.DecodeResponse](c.Transport, c.Server, "Decode", ctx, req)
}

func (c *Client) Encode(ctx context.Context, req *api.EncodeRequest) (*api.EncodeResponse, error) {
	return callClient[*api.EncodeResponse](c.Transport, c.Server, "Encode", ctx, req)
}

func (c *Client) GenerateMnemonic(ctx context.Context, req *api.GenerateMnemonicRequest) (*api.GenerateMnemonicResponse, error) {
	return callClient[*api.GenerateMnemonicResponse](c.Transport, c.Server, "GenerateMnemonic", ctx, req)
}

func (c *Client) RefreshToken(ctx context.Context, req *api.RefreshTokenRequest) (*api.RefreshTokenResponse, error) {
	return callClient[*api.RefreshTokenResponse](c.Transport, c.Server, "RefreshToken", ctx, req)
}

func (c *Client) Version(ctx context.Context) (*api.VersionResponse, error) {
	return callClient[*api.VersionResponse](c.Transport, c.Server, "Version", ctx, json.RawMessage("{}"))
}

func (c *Client) AdoptVault(ctx context.Context, req *api.AdoptVaultRequest) (*api.AdoptVaultResponse, error) {
	return callClient[*api.AdoptVaultResponse](c.Transport, c.Server, "AdoptVault", ctx, req)
}

func (c *Client) ConvertWallet(ctx context.Context, req *api.ConvertWalletRequest) (*api.ConvertWalletResponse, error) {
	return callClient[*api.ConvertWalletResponse](c.Transport, c.Server, "ConvertWallet", ctx, req)
}

func (c *Client) CopyVaultSanitized(ctx context.Context, req *api.CopyVaultSanitizedRequest) (*api.CopyVaultSanitizedResponse, error) {
	return callClient[*api.CopyVaultSanitizedResponse](c.Transport, c.Server, "CopyVaultSanitized", ctx, req)
}

func (c *Client) CreateVault(ctx context.Context, req *api.CreateVaultRequest) (*api.CreateVaultResponse, error) {
	return callClient[*api.CreateVaultResponse](c.Transport, c.Server, "CreateVault", ctx, req)
}

func (c *Client) CreateWallet(ctx context.Context, req *api.CreateWalletRequest) (*api.CreateWalletResponse, error) {
	return callClient[*api.CreateWalletResponse](c.Transport, c.Server, "CreateWallet", ctx, req)
}

func (c *Client) EncryptVault(ctx context.Context, req *api.EncryptVaultRequest) (*api.EncryptVaultResponse, error) {
	return callClient[*api.EncryptVaultResponse](c.Transport, c.Server, "EncryptVault", ctx, req)
}

func (c *Client) ExportVault(ctx context.Context, req *api.ExportVaultRequest) (*api.ExportVaultResponse, error) {
	return callClient[*api.ExportVaultResponse](c.Transport, c.Server, "ExportVault", ctx, req)
}

func (c *Client) ImportMnemonic(ctx context.Context, req *api.ImportMnemonicRequest) (*api.ImportMnemonicResponse, error) {
	return callClient[*api.ImportMnemonicResponse](c.Transport, c.Server, "ImportMnemonic", ctx, req)
}

func (c *Client) ImportVault(ctx context.Context, req *api.ImportVaultRequest) (*api.ImportVaultResponse, error) {
	return callClient[*api.ImportVaultResponse](c.Transport, c.Server, "ImportVault", ctx, req)
}

func (c *Client) ListVaults(ctx context.Context, req *api.ListVaultsRequest) (*api.ListVaultsResponse, error) {
	return callClient[*api.ListVaultsResponse](c.Transport, c.Server, "ListVaults", ctx, req)
}

func (c *Client) LockVault(ctx context.Context, req *api.LockVaultRequest) (*api.LockVaultResponse, error) {
	return callClient[*api.LockVaultResponse](c.Transport, c.Server, "LockVault", ctx, req)
}

func (c *Client) OpenVault(ctx context.Context, req *api.OpenVaultRequest) (*api.OpenVaultResponse, error) {
	return callClient[*api.OpenVaultResponse](c.Transport, c.Server, "OpenVault", ctx, req)
}

func (c *Client) Set1PasswordRef(ctx context.Context, req *api.Set1PasswordRefRequest) (*api.Set1PasswordRefResponse, error) {
	return callClient[*api.Set1PasswordRefResponse](c.Transport, c.Server, "Set1PasswordRef", ctx, req)
}

func (c *Client) Status(ctx context.Context, req *api.StatusRequest) (*api.StatusResponse, error) {
	return callClient[*api.StatusResponse](c.Transport, c.Server, "Status", ctx, req)
}

func (c *Client) UnlockVault(ctx context.Context, req *api.UnlockVaultRequest) (*api.UnlockVaultResponse, error) {
	return callClient[*api.UnlockVaultResponse](c.Transport, c.Server, "UnlockVault", ctx, req)
}

func (c *Client) AddMemoToTransaction(ctx context.Context, req *api.AddMemoToTransactionRequest) (*api.TransactionResponse, error) {
	return callClient[*api.TransactionResponse](c.Transport, c.Server, "AddMemoToTransaction", ctx, req)
}

func (c *Client) AddSendTokensOutput(ctx context.Context, req *api.AddSendTokensOutputRequest) (*api.TransactionResponse, error) {
	return callClient[*api.TransactionResponse](c.Transport, c.Server, "AddSendTokensOutput", ctx, req)
}

func (c *Client) CreateEnvelope(ctx context.Context, req *api.CreateEnvelopeRequest) (*api.CreateEnvelopeResponse, error) {
	return callClient[*api.CreateEnvelopeResponse](c.Transport, c.Server, "CreateEnvelope", ctx, req)
}

func (c *Client) CreateTransaction(ctx context.Context, req *api.CreateTransactionRequest) (*api.TransactionResponse, error) {
	return callClient[*api.TransactionResponse](c.Transport, c.Server, "CreateTransaction", ctx, req)
}

func (c *Client) DeleteTransaction(ctx context.Context, req *api.DeleteTransactionRequest) (*api.TransactionResponse, error) {
	return callClient[*api.TransactionResponse](c.Transport, c.Server, "DeleteTransaction", ctx, req)
}

func (c *Client) GetTransaction(ctx context.Context, req *api.GetTransactionRequest) (*api.TransactionResponse, error) {
	return callClient[*api.TransactionResponse](c.Transport, c.Server, "GetTransaction", ctx, req)
}

func (c *Client) ListTransactions(ctx context.Context, req *api.ListTransactionsRequest) (*api.ListTransactionsResponse, error) {
	return callClient[*api.ListTransactionsResponse](c.Transport, c.Server, "ListTransactions", ctx, req)
}

func (c *Client) WriteDataTransaction(ctx context.Context, req *api.WriteDataRequest) (*api.TransactionResponse, error) {
	return callClient[*api.TransactionResponse](c.Transport, c.Server, "WriteDataTransaction", ctx, req)
}

func (c *Client) FindSigner(ctx context.Context, req *api.FindSignerRequest) (*api.FindSignerResponse, error) {
	return callClient[*api.FindSignerResponse](c.Transport, c.Server, "FindSigner", ctx, req)
}

func (c *Client) GenerateAddress(ctx context.Context, req *api.GenerateAddressRequest) (*api.GenerateAddressResponse, error) {
	return callClient[*api.GenerateAddressResponse](c.Transport, c.Server, "GenerateAddress", ctx, req)
}

func (c *Client) ImportKey(ctx context.Context, req *api.ImportKeyRequest) (*api.ResolveKeyResponse, error) {
	return callClient[*api.ResolveKeyResponse](c.Transport, c.Server, "ImportKey", ctx, req)
}

func (c *Client) KeyAssign(ctx context.Context, req *api.KeyRotateRequest) (*api.KeyRotateResponse, error) {
	return callClient[*api.KeyRotateResponse](c.Transport, c.Server, "KeyAssign", ctx, req)
}

func (c *Client) KeyList(ctx context.Context, req *api.KeyListRequest) (*api.KeyListResponse, error) {
	return callClient[*api.KeyListResponse](c.Transport, c.Server, "KeyList", ctx, req)
}

func (c *Client) KeyRemove(ctx context.Context, req *api.KeyRotateRequest) (*api.KeyRotateResponse, error) {
	return callClient[*api.KeyRotateResponse](c.Transport, c.Server, "KeyRemove", ctx, req)
}

func (c *Client) KeyRename(ctx context.Context, req *api.KeyRotateRequest) (*api.KeyRotateResponse, error) {
	return callClient[*api.KeyRotateResponse](c.Transport, c.Server, "KeyRename", ctx, req)
}

func (c *Client) ResolveKey(ctx context.Context, req *api.ResolveKeyRequest) (*api.ResolveKeyResponse, error) {
	return callClient[*api.ResolveKeyResponse](c.Transport, c.Server, "ResolveKey", ctx, req)
}

func (c *Client) RestoreKeyCounters(ctx context.Context, req *api.RestoreKeyCountersRequest) (*api.RestoreKeyCountersResponse, error) {
	return callClient[*api.RestoreKeyCountersResponse](c.Transport, c.Server, "RestoreKeyCounters", ctx, req)
}

func (c *Client) LedgerGenerateKey(ctx context.Context, req *api.GenerateLedgerKeyRequest) (*api.Key, error) {
	return callClient[*api.Key](c.Transport, c.Server, "LedgerGenerateKey", ctx, req)
}

func (c *Client) LedgerQueryWallets(ctx context.Context) (*api.LedgerWalletResponse, error) {
	return callClient[*api.LedgerWalletResponse](c.Transport, c.Server, "LedgerQueryWallets", ctx, json.RawMessage("{}"))
}

func (c *Client) AdiList(ctx context.Context, req *api.AdiListRequest) (*api.AdiListResponse, error) {
	return callClient[*api.AdiListResponse](c.Transport, c.Server, "AdiList", ctx, req)
}

func (c *Client) ListAccounts(ctx context.Context, req *api.ListAccountsRequest) (*api.ListAccountsResponse, error) {
	return callClient[*api.ListAccountsResponse](c.Transport, c.Server, "ListAccounts", ctx, req)
}

func (c *Client) RegisterADI(ctx context.Context, req *api.RegisterADIRequest) (*api.RegisterADIResponse, error) {
	return callClient[*api.RegisterADIResponse](c.Transport, c.Server, "RegisterADI", ctx, req)
}

func (c *Client) RegisterBook(ctx context.Context, req *api.RegisterBookRequest) (*api.RegisterBookResponse, error) {
	return callClient[*api.RegisterBookResponse](c.Transport, c.Server, "RegisterBook", ctx, req)
}

func (c *Client) RegisterTokenAccount(ctx context.Context, req *api.RegisterTokenAccountRequest) (*api.RegisterTokenAccountResponse, error) {
	return callClient[*api.RegisterTokenAccountResponse](c.Transport, c.Server, "RegisterTokenAccount", ctx, req)
}

func (c *Client) UnregisterBook(ctx context.Context, req *api.UnregisterBookRequest) (*api.UnregisterBookResponse, error) {
	return callClient[*api.UnregisterBookResponse](c.Transport, c.Server, "UnregisterBook", ctx, req)
}

func (c *Client) UnregisterTokenAccount(ctx context.Context, req *api.UnregisterTokenAccountRequest) (*api.UnregisterTokenAccountResponse, error) {
	return callClient[*api.UnregisterTokenAccountResponse](c.Transport, c.Server, "UnregisterTokenAccount", ctx, req)
}

func (c *Client) ResetLastUsedOn(ctx context.Context, req *api.ResetLastUsedOnRequest) (*api.ResetLastUsedOnResponse, error) {
	return callClient[*api.ResetLastUsedOnResponse](c.Transport, c.Server, "ResetLastUsedOn", ctx, req)
}

func (c *Client) Sign(ctx context.Context, req *api.SignRequest) (*api.SignResponse, error) {
	return callClient[*api.SignResponse](c.Transport, c.Server, "Sign", ctx, req)
}

func (c *Client) SignMessage(ctx context.Context, req *api.SignMessageRequest) (*api.SignResponse, error) {
	return callClient[*api.SignResponse](c.Transport, c.Server, "SignMessage", ctx, req)
}

func (c *Client) SignTransaction(ctx context.Context, req *api.SignTransactionRequest) (*api.SignResponse, error) {
	return callClient[*api.SignResponse](c.Transport, c.Server, "SignTransaction", ctx, req)
}
